﻿; PB 5.73 LTS
;
; Problem
; =======
; 3 dice are rolled.
; Which of the following events is more likely:
; A) The total number of points is nine or less.
; B) At least two dice show the same number of points.

XIncludeFile "set.pbi"


If #PB_Compiler_Debugger = #False
   MessageRequester("set_demo_coalitions", "Switch Debugger on!")
   End
EndIf

EnableExplicit


Procedure.i Sum (tuple$)
   ; -- return the total number of points of all dice in the tuple
   Protected.i i, ret=0
   
   For i = 1 To 3
      ret + Val(StringField(tuple$, i, ","))
   Next
   
   ProcedureReturn ret
EndProcedure

Procedure.i DiffDice (tuple$)
   ; -- return the number of dice in the tuple that show different numbers of points
   Protected.Set::Set x
   
   Set::FromString(x, tuple$)    ; A set can only hold different elements.
   ProcedureReturn Set::Size(x)
EndProcedure


Define.i n, CountA=0, CountB=0
Define.Set::Set A, Interim, P

; -- generate all 216 tuples of points that are possible as a result of rolling 3 dice
Set::Create(A, 1, 6)
Set::Product(A, A, Interim, #False)
n = Set::Product(Interim, A, P, #False)

; -- check all tuples
ForEach P\Element()
   If Sum(MapKey(P\Element())) <= 9
      CountA + 1
   EndIf   
   
   If DiffDice(MapKey(P\Element())) < 3
      CountB + 1
   EndIf   
Next

Debug "Probabilities:"
Debug "P(A) = " + CountA + "/" + n   ; 81/216
Debug "P(B) = " + CountB + "/" + n   ; 96/216
Debug ""
Debug "Answer:"
If CountA > CountB
   Debug "Event A is more likely."
ElseIf CountA < CountB
   Debug "Event B is more likely."
Else    
   Debug "Both events are equally likely."
EndIf

; IDE Options = PureBasic 5.73 LTS (Windows - x64)
; Folding = -
; EnableXP
; EnableUser
; DPIAware
; EnableExeConstant